
/*  A Bison parser, made from hal_parser.y  */

#define	EOSC	258
#define	DOT	259
#define	CL	260
#define	CA	261
#define	RP	262
#define	LP	263
#define	PD	264
#define	NL	265
#define	OR	266
#define	XOR	267
#define	REG	268
#define	INS_PAL	269
#define	INS_MEM	270
#define	INS_HWM	271
#define	INS_BRN	272
#define	INS_FOP	273
#define	INS_FP2	274
#define	INS_IOP	275
#define	INS_MIS	276
#define	INS_M1A	277
#define	INS_M1B	278
#define	IMMED	279
#define	IM64	280
#define	ALIGN	281
#define	QUAD	282
#define	LONG	283
#define	ADDR	284
#define	BLKL	285
#define	BLKQ	286
#define	ENDP	287
#define	SYMB	288
#define	IPRS	289
#define	COMMENT	290

#line 1 "hal_parser.y"

/*****************************************************************************/
/*FILE: HAL_PARSER.Y	Grammer Analyzer (use with BISON or YACC)	     */
/*****************************************************************************
	Copyright (c) 1992
	Digital Equipment Corporation, Maynard, Massachusetts 01754

	The HAL Alpha Assembler is free software; you can redistribute 
	it and/or modify it with the sole restriction that this copyright 
	notice be attached.

	The information in this software is subject to change without notice 
	and should not be construed as a commitment by Digital Equipment
	Corporation.

	The author disclaims all warranties with regard to this software,
	including all implied warranties of merchantability and fitness, in
	no event shall he be liable for any special, indirect or consequential
	damages or any damages whatsoever resulting from loss of use, data, 
	or profits, whether in an action of contract, negligence or other
	tortious action, arising out of or in connection with the use or
	performance of this software.
 *****************************************************************************/
/* Originally Created by: Homayoon Akhiani	April,1992		     */
/*****************************************************************************
! REVISION HISTORY:
! Who   When            What
!---------------------------------------------------------------
! HA	16-Jul-1992	HW_LD,HW_ST
! HA	20-May-1992	Fix the bug in .LONG, add .ALIGN x, fill value
! HA	01-May-1992	Add more misc. RPCC, FETCH,...
! HA    23-Apr-1992	Include stdlib.h (for portability)    
! HA	17-Apr-1992	.ALIGN mask corrected
! HA    xx-Apr-1992     First pass
 *****************************************************************************/
/*****************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "hal.h"
#define alloca  malloc
#define YYSTYPE char*
#define YYDEBUG 1
YYSTYPE	add();
extern XREF *ref;
extern char Sline[];
extern int  Kcode;
extern int  line_number;	/* Source line number */
extern FILE *yyin;		/* Input stream */
extern FILE *Ot;
extern B32  Opc, hpc, pc, ic;
extern B32  *m;
extern B32  Sa[];

B32	    R[2];
B32    	    ev[2],o1[2],o2[2];	/* Experation evaluation parameters*/
char	    Sym[SYSZ];
char	    S1[SYSZ],
	    S2[SYSZ],
	    S3[SYSZ];		/* Hold the symbol name */		
int	    li;			/* index for the label*/
int	    Reg, 
	    sop,		/* Symbolic operation */
	    st;			/* Status of the last symget */

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __STDC__
#define const
#endif



#define	YYFINAL		161
#define	YYFLAG		-32768
#define	YYNTBASE	42

#define YYTRANSLATE(x) ((unsigned)(x) <= 290 ? yytranslate[x] : 71)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,    39,     2,     2,
     2,     2,    37,     2,    36,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    38,     2,     2,    40,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,    41,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35
};

static const short yyprhs[] = {     0,
     0,     2,     5,     6,     8,    10,    12,    14,    18,    21,
    23,    25,    27,    30,    33,    34,    40,    41,    50,    51,
    61,    66,    71,    74,    79,    81,    83,    86,    89,    92,
    95,    98,   101,   104,   109,   114,   115,   121,   125,   129,
   133,   137,   141,   145,   148,   150,   152,   154,   156,   158,
   160,   162,   164,   166,   168,   170,   172,   174,   176,   178,
   180,   182,   184,   186,   188,   190,   191,   194,   197,   200,
   201,   203,   205,   207,   208,   210,   212,   214,   216,   218,
   220,   222,   223,   224,   232,   235,   236,   241,   242,   248,
   249,   255,   256,   262,   265,   268,   269,   274
};

static const short yyrhs[] = {    43,
     0,    42,    43,     0,     0,    35,     0,    48,     0,    44,
     0,    49,     0,    33,     5,     5,     0,    33,     5,     0,
    32,     0,    10,     0,     1,     0,    18,    61,     0,    19,
    69,     0,     0,    20,    13,    45,     6,    64,     0,     0,
    15,    13,    46,     6,    59,     8,    13,     7,     0,     0,
    16,    13,    47,     6,    58,     8,    13,     7,    57,     0,
    17,    13,     6,    60,     0,    14,    13,     6,    54,     0,
    22,    13,     0,    23,     8,    13,     7,     0,    21,     0,
     1,     0,    30,    52,     0,    31,    52,     0,    29,    56,
     0,    27,    56,     0,    28,    55,     0,    26,    24,     0,
    26,    25,     0,    26,    52,     6,    53,     0,     4,    38,
    51,    10,     0,     0,    33,    50,    38,    51,    10,     0,
    52,    37,    53,     0,    52,    36,    53,     0,    52,    39,
    53,     0,    52,    11,    53,     0,    52,    12,    53,     0,
    52,    40,    53,     0,    52,    41,     0,    52,     0,     1,
     0,     4,     0,    24,     0,    25,     0,    33,     0,     1,
     0,     4,     0,    24,     0,    25,     0,    33,     0,     1,
     0,    24,     0,    25,     0,    34,     0,    24,     0,    25,
     0,    33,     0,    24,     0,    25,     0,    33,     0,     0,
     6,    33,     0,     6,    24,     0,     6,    25,     0,     0,
    33,     0,    24,     0,    25,     0,     0,    33,     0,    24,
     0,    25,     0,    33,     0,    24,     0,    25,     0,     4,
     0,     0,     0,    13,     6,    62,    13,     6,    63,    13,
     0,    13,     1,     0,     0,    13,     6,    65,    13,     0,
     0,     9,    24,     6,    66,    13,     0,     0,     9,    25,
     6,    67,    13,     0,     0,     9,    33,     6,    68,    13,
     0,    33,     1,     0,    13,     1,     0,     0,    13,     6,
    70,    13,     0,    13,     1,     0
};

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   106,   108,   110,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   123,   125,   126,   127,   128,   129,   130,   131,
   132,   133,   134,   135,   136,   137,   139,   141,   142,   143,
   144,   145,   146,   147,   149,   151,   152,   155,   157,   158,
   159,   160,   161,   163,   164,   165,   167,   169,   170,   171,
   172,   174,   176,   177,   178,   179,   181,   183,   184,   186,
   188,   189,   191,   193,   194,   197,   199,   200,   201,   203,
   205,   206,   207,   209,   211,   212,   213,   215,   217,   218,
   219,   221,   223,   224,   225,   227,   229,   230,   231,   232,
   233,   234,   235,   236,   237,   239,   241,   242
};

static const char * const yytname[] = {   "$",
"error","$illegal.","EOSC","DOT","CL","CA","RP","LP","PD","NL",
"OR","XOR","REG","INS_PAL","INS_MEM","INS_HWM","INS_BRN","INS_FOP","INS_FP2","INS_IOP",
"INS_MIS","INS_M1A","INS_M1B","IMMED","IM64","ALIGN","QUAD","LONG","ADDR","BLKL",
"BLKQ","ENDP","SYMB","IPRS","COMMENT","'-'","'+'","'='","'&'","'@'",
"'~'","Lines","Line","Instruction","@1","@2","@3","Directive","Assigment","@4",
"Assign","Oper1","Oper2","Ipr","Lnumber","Qnumber","Mode","Disp12","Disp16","Disp21",
"ThreeFReg","@5","@6","IReg","@7","@8","@9","@10","TwoReg","@11",
""
};
#endif

static const short yyr1[] = {     0,
    42,    42,    43,    43,    43,    43,    43,    43,    43,    43,
    43,    43,    44,    44,    45,    44,    46,    44,    47,    44,
    44,    44,    44,    44,    44,    44,    48,    48,    48,    48,
    48,    48,    48,    48,    49,    50,    49,    51,    51,    51,
    51,    51,    51,    51,    51,    51,    52,    52,    52,    52,
    52,    53,    53,    53,    53,    53,    54,    54,    54,    55,
    55,    55,    56,    56,    56,    57,    57,    57,    57,    58,
    58,    58,    58,    59,    59,    59,    59,    60,    60,    60,
    60,    62,    63,    61,    61,    65,    64,    66,    64,    67,
    64,    68,    64,    64,    64,    70,    69,    69
};

static const short yyr2[] = {     0,
     1,     2,     0,     1,     1,     1,     1,     3,     2,     1,
     1,     1,     2,     2,     0,     5,     0,     8,     0,     9,
     4,     4,     2,     4,     1,     1,     2,     2,     2,     2,
     2,     2,     2,     4,     4,     0,     5,     3,     3,     3,
     3,     3,     3,     2,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     0,     2,     2,     2,     0,
     1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
     1,     0,     0,     7,     2,     0,     4,     0,     5,     0,
     5,     0,     5,     2,     2,     0,     4,     2
};

static const short yydefact[] = {     0,
    12,     0,    11,     0,     0,     0,     0,     0,     0,     0,
    25,     0,     0,     0,     0,     0,     0,     0,     0,    10,
    36,     4,     0,     1,     6,     5,     7,     0,     0,    17,
    19,     0,     0,    13,     0,    14,    15,    23,     0,    51,
    47,    32,    33,    50,     0,    63,    64,    65,    30,    60,
    61,    62,    31,    29,    48,    49,    27,    28,     9,     0,
     2,    51,     0,    45,     0,     0,     0,     0,    85,    82,
    98,    96,     0,     0,     0,     8,     0,    35,     0,     0,
     0,     0,     0,     0,    44,    57,    58,    59,    22,    74,
    70,    81,    79,    80,    78,    21,     0,     0,     0,    24,
    56,    52,    53,    54,    55,    34,     0,    41,    42,    39,
    38,    40,    43,    76,    77,    75,     0,    72,    73,    71,
     0,     0,    97,     0,     0,     0,    16,    37,     0,     0,
    83,     0,     0,     0,    95,    86,    94,     0,     0,     0,
    88,    90,    92,     0,    18,    66,    84,     0,     0,     0,
    87,     0,    20,    89,    91,    93,    68,    69,    67,     0,
     0
};

static const short yydefgoto[] = {    23,
    24,    25,    73,    66,    67,    26,    27,    60,    63,    64,
   106,    89,    53,    49,   153,   121,   117,    96,    34,    97,
   140,   127,   144,   148,   149,   150,    36,    98
};

static const short yypact[] = {     0,
-32768,   -33,-32768,    -6,    -4,    11,    12,    21,    28,    29,
-32768,    32,    35,    69,    14,    85,    14,    71,    71,-32768,
    76,-32768,    36,-32768,-32768,-32768,-32768,    73,    72,-32768,
-32768,    78,     5,-32768,     7,-32768,-32768,-32768,    67,-32768,
-32768,    86,    95,-32768,    97,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    77,    79,
-32768,   109,   111,    49,   -22,    99,   117,    87,-32768,-32768,
-32768,-32768,   123,   124,    75,-32768,    73,-32768,    75,    75,
    75,    75,    75,    75,-32768,-32768,-32768,-32768,-32768,    89,
    91,-32768,-32768,-32768,-32768,-32768,   119,   120,    74,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   133,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,   136,-32768,-32768,-32768,
   137,   140,-32768,   101,   129,   146,-32768,-32768,   135,   138,
-32768,   143,   144,   147,-32768,-32768,-32768,   145,   148,   141,
-32768,-32768,-32768,   149,-32768,   150,-32768,   151,   152,   153,
-32768,   103,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   157,
-32768
};

static const short yypgoto[] = {-32768,
   154,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    81,    30,
    58,-32768,-32768,   142,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768
};


#define	YYLAST		177


static const short yytable[] = {    -3,
     1,    86,    87,     2,    28,    69,    29,    71,    30,     3,
    70,    88,    72,     4,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    31,    32,    14,    15,    16,    17,    18,
    19,    20,    21,    33,    22,   160,     1,    46,    47,     2,
    35,    37,    39,    45,    38,     3,    48,    57,    58,     4,
     5,     6,     7,     8,     9,    10,    11,    12,    13,    79,
    80,    14,    15,    16,    17,    18,    19,    20,    21,    40,
    22,    40,    41,    62,    41,   101,    41,    65,   102,    74,
    59,    76,   124,    68,    81,    82,   125,    83,    84,    85,
    92,   -48,    42,    43,    55,    56,    55,    56,   103,   104,
   -49,    44,    75,    44,    90,    44,   126,   105,    50,    51,
    93,    94,   114,   115,   118,   119,    77,    52,   -46,    95,
    78,   116,    91,   120,   132,   133,   157,   158,    99,   135,
   100,   122,   123,   134,   136,   159,   108,   109,   110,   111,
   112,   113,   128,   129,   130,   131,   137,   138,   141,   142,
   139,   145,   143,   147,   146,   152,   161,   107,    54,     0,
     0,   151,     0,   154,   155,   156,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    61
};

static const short yycheck[] = {     0,
     1,    24,    25,     4,    38,     1,    13,     1,    13,    10,
     6,    34,     6,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    13,    13,    26,    27,    28,    29,    30,
    31,    32,    33,    13,    35,     0,     1,    24,    25,     4,
    13,    13,     8,    14,    13,    10,    33,    18,    19,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    11,
    12,    26,    27,    28,    29,    30,    31,    32,    33,     1,
    35,     1,     4,     1,     4,     1,     4,     6,     4,    13,
     5,     5,     9,     6,    36,    37,    13,    39,    40,    41,
     4,     6,    24,    25,    24,    25,    24,    25,    24,    25,
     6,    33,     6,    33,     6,    33,    33,    33,    24,    25,
    24,    25,    24,    25,    24,    25,    38,    33,    10,    33,
    10,    33,     6,    33,    24,    25,    24,    25,     6,     1,
     7,    13,    13,    33,     6,    33,    79,    80,    81,    82,
    83,    84,    10,     8,     8,     6,     1,    13,     6,     6,
    13,     7,     6,    13,     7,     6,     0,    77,    17,    -1,
    -1,    13,    -1,    13,    13,    13,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    23
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#include <alloca.h>
#else /* Not sparc */
#ifdef MSDOS
#include <malloc.h>
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif

#line 160 "bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/

#define YYPOPSTACK   (yyvsp--, yysp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yysp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
#ifdef YYLSP_NEEDED
		 &yyls1, size * sizeof (*yylsp),
#endif
		 &yystacksize);

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Next token is %d (%s)\n", yychar, yytname[yychar1]);
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symboles being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 4:
#line 112 "hal_parser.y"
{rs();;
    break;}
case 5:
#line 113 "hal_parser.y"
{rs();;
    break;}
case 6:
#line 114 "hal_parser.y"
{rs();;
    break;}
case 7:
#line 115 "hal_parser.y"
{line_number++;rs();;
    break;}
case 8:
#line 116 "hal_parser.y"
{symdef(Sym,hpc,pc,NULL,NULL,NONE);rs();;
    break;}
case 9:
#line 117 "hal_parser.y"
{symdef(Sym,hpc,pc,NULL,NULL,NONE);rs();;
    break;}
case 10:
#line 118 "hal_parser.y"
{fprintf(Ot,"EoPROGRAM\n"); endline();return;;
    break;}
case 11:
#line 119 "hal_parser.y"
{line_number++; nl();rs();;
    break;}
case 12:
#line 120 "hal_parser.y"
{yyerror("Unknown statement");;
    break;}
case 13:
#line 124 "hal_parser.y"
{dbug();m[ic++]=Opc;ipc(4);;
    break;}
case 14:
#line 125 "hal_parser.y"
{dbug();m[ic++]=Opc;ipc(4);;
    break;}
case 15:
#line 126 "hal_parser.y"
{Opc|=(Reg<<21);;
    break;}
case 16:
#line 127 "hal_parser.y"
{dbug();m[ic++]=Opc;ipc(4);;
    break;}
case 17:
#line 128 "hal_parser.y"
{Opc|=(Reg<<21);;
    break;}
case 18:
#line 129 "hal_parser.y"
{dbug();m[ic++]=Opc|(Reg<<16);ipc(4);;
    break;}
case 19:
#line 130 "hal_parser.y"
{Opc|=(Reg<<21);;
    break;}
case 20:
#line 131 "hal_parser.y"
{dbug();m[ic++]=Opc|(Reg<<16);ipc(4);;
    break;}
case 21:
#line 132 "hal_parser.y"
{dbug();m[ic++]=Opc|(Reg<<21);ipc(4);;
    break;}
case 22:
#line 133 "hal_parser.y"
{dbug();m[ic++]=Opc|(Reg<<21)|(Reg<<16);ipc(4);;
    break;}
case 23:
#line 134 "hal_parser.y"
{dbug();m[ic++]=Opc|(Reg<<21);ipc(4);;
    break;}
case 24:
#line 135 "hal_parser.y"
{dbug();m[ic++]=Opc|(Reg<<16);ipc(4);;
    break;}
case 25:
#line 136 "hal_parser.y"
{dbug();m[ic++]=Opc;ipc(4);;
    break;}
case 26:
#line 137 "hal_parser.y"
{yyerror("Unknown instruction");;
    break;}
case 27:
#line 140 "hal_parser.y"
{ipc(o1[0]);   uic();;
    break;}
case 28:
#line 141 "hal_parser.y"
{ipc(o1[0]<<2);uic();;
    break;}
case 29:
#line 142 "hal_parser.y"
{;
    break;}
case 30:
#line 143 "hal_parser.y"
{;
    break;}
case 31:
#line 144 "hal_parser.y"
{;
    break;}
case 32:
#line 145 "hal_parser.y"
{apc(R[0]); nl();;
    break;}
case 33:
#line 146 "hal_parser.y"
{apc(R[0]); nl();;
    break;}
case 34:
#line 147 "hal_parser.y"
{apcf(o1[0],o2[0]); nl();;
    break;}
case 35:
#line 150 "hal_parser.y"
{spc(ev[1],ev[0]);endline();;
    break;}
case 36:
#line 151 "hal_parser.y"
{strcpy(S1,Sym);;
    break;}
case 37:
#line 152 "hal_parser.y"
{symdef(S1,ev[1],ev[0],S2,S3,sop); endline();;
    break;}
case 38:
#line 156 "hal_parser.y"
{ADD64(o1,o2,ev); if(st & 1)sop=OADD;;
    break;}
case 39:
#line 157 "hal_parser.y"
{SUB64(o1,o2,ev); if(st & 1)sop=OSUB;;
    break;}
case 40:
#line 158 "hal_parser.y"
{ev[0]=o1[0] & o2[0];ev[1]=o1[1] & o2[1]; if(st & 1)sop=OAND;;
    break;}
case 41:
#line 159 "hal_parser.y"
{ev[0]=o1[0] | o2[0];ev[1]=o1[1] | o2[1]; if(st & 1)sop=OORR;;
    break;}
case 42:
#line 160 "hal_parser.y"
{ev[0]=o1[0] ^ o2[0];ev[1]=o1[1] ^ o2[1]; if(st & 1)sop=OXOR;;
    break;}
case 43:
#line 161 "hal_parser.y"
{ev[0]=((int)o2[0]<0) ? (o1[0]>> (-(int)(o2[0])))
					      : (o1[0]<<o2[0]);;
    break;}
case 44:
#line 163 "hal_parser.y"
{ev[0]= ~o1[0];ev[1]= ~o1[1];;
    break;}
case 45:
#line 164 "hal_parser.y"
{ev[0]=o1[0];ev[1]=o1[1]; if(st & 1)sop=OONE;;
    break;}
case 46:
#line 165 "hal_parser.y"
{yyerror("No operand for the Assignment");;
    break;}
case 47:
#line 168 "hal_parser.y"
{o1[0]=pc; sprintf(S2,"^x%x%08x",hpc,pc);;
    break;}
case 48:
#line 169 "hal_parser.y"
{o1[0]=R[0];o1[1]=R[1];sprintf(S2,"^x%x%08x",R[1],R[0]);;
    break;}
case 49:
#line 170 "hal_parser.y"
{o1[0]=R[0];o1[1]=R[1];sprintf(S2,"^x%x%08x",R[1],R[0]);;
    break;}
case 50:
#line 171 "hal_parser.y"
{st|=symget(Sym,R); strcpy(S2,Sym); o1[0]=R[0];o1[1]=R[1];;
    break;}
case 51:
#line 172 "hal_parser.y"
{yyerror("Bad 1st Operand");;
    break;}
case 52:
#line 175 "hal_parser.y"
{o2[0]=pc; sprintf(S3,"^x%x%08x",hpc,pc);;
    break;}
case 53:
#line 176 "hal_parser.y"
{o2[0]=R[0];o2[1]=R[1];sprintf(S3,"^x%x%08x",R[1],R[0]);;
    break;}
case 54:
#line 177 "hal_parser.y"
{o2[0]=R[0];o2[1]=R[1];sprintf(S3,"^x%x%08x",R[1],R[0]);;
    break;}
case 55:
#line 178 "hal_parser.y"
{st|=symget(Sym,R); strcpy(S3,Sym); o2[0]=R[0];o2[1]=R[1];;
    break;}
case 56:
#line 179 "hal_parser.y"
{yyerror("Bad 2nd Operand");;
    break;}
case 57:
#line 182 "hal_parser.y"
{Opc|=R[0];;
    break;}
case 58:
#line 183 "hal_parser.y"
{Opc|=R[0];;
    break;}
case 59:
#line 184 "hal_parser.y"
{Opc|=R[0];;
    break;}
case 60:
#line 187 "hal_parser.y"
{db();m[ic++]=R[0];ipc(4);;
    break;}
case 61:
#line 188 "hal_parser.y"
{db();m[ic++]=R[0];ipc(4);;
    break;}
case 62:
#line 189 "hal_parser.y"
{symuse(Sym,TD32);db();m[ic++]=0xADD;ipc(4);;
    break;}
case 63:
#line 192 "hal_parser.y"
{db();m[ic++]=R[0];db();m[ic++]=R[1]; ipc(8);;
    break;}
case 64:
#line 193 "hal_parser.y"
{db();m[ic++]=R[0];db();m[ic++]=R[1]; ipc(8);;
    break;}
case 65:
#line 194 "hal_parser.y"
{symuse(Sym,TD64);db();m[ic++]=0xADD;
					  db();m[ic++]=0xADD;ipc(8);;
    break;}
case 67:
#line 199 "hal_parser.y"
{symuse(Sym,TMOD);;
    break;}
case 68:
#line 200 "hal_parser.y"
{Opc |= (R[0] & 0xF) << 12;;
    break;}
case 69:
#line 201 "hal_parser.y"
{Opc |= (R[0] & 0xF) << 12;;
    break;}
case 70:
#line 204 "hal_parser.y"
{;
    break;}
case 71:
#line 205 "hal_parser.y"
{symuse(Sym,TMHW);;
    break;}
case 72:
#line 206 "hal_parser.y"
{Opc |= R[0] & 0xFFF;;
    break;}
case 73:
#line 207 "hal_parser.y"
{Opc |= R[0] & 0xFFF;;
    break;}
case 74:
#line 210 "hal_parser.y"
{;
    break;}
case 75:
#line 211 "hal_parser.y"
{symuse(Sym,TMDS);;
    break;}
case 76:
#line 212 "hal_parser.y"
{Opc |= R[0] & 0xFFFF;;
    break;}
case 77:
#line 213 "hal_parser.y"
{Opc |= R[0] & 0xFFFF;;
    break;}
case 78:
#line 216 "hal_parser.y"
{symuse(Sym,TBDS);;
    break;}
case 79:
#line 217 "hal_parser.y"
{Opc |= 0x1FFFFF & R[0];;
    break;}
case 80:
#line 218 "hal_parser.y"
{Opc |= 0x1FFFFF & R[0];;
    break;}
case 81:
#line 219 "hal_parser.y"
{Opc |= 0x1FFFFF & (0>>2);;
    break;}
case 82:
#line 222 "hal_parser.y"
{Opc |= (Reg<<21); ;
    break;}
case 83:
#line 223 "hal_parser.y"
{Opc |= (Reg<<16); ;
    break;}
case 84:
#line 224 "hal_parser.y"
{Opc |= (Reg);	   ;
    break;}
case 85:
#line 225 "hal_parser.y"
{yyerror("Syntax, FRegisters?");;
    break;}
case 86:
#line 228 "hal_parser.y"
{Opc |= (Reg<<16); ;
    break;}
case 87:
#line 229 "hal_parser.y"
{Opc |= (Reg);     ;
    break;}
case 88:
#line 230 "hal_parser.y"
{Opc |= (R[0]<<13); Opc|=0x1000;;
    break;}
case 89:
#line 231 "hal_parser.y"
{Opc |= (Reg);     ;
    break;}
case 90:
#line 232 "hal_parser.y"
{Opc |= (R[0]<<13); Opc|=0x1000;;
    break;}
case 91:
#line 233 "hal_parser.y"
{Opc |= (Reg);     ;
    break;}
case 92:
#line 234 "hal_parser.y"
{symuse(Sym,TIOP); Opc|=0x1000;;
    break;}
case 93:
#line 235 "hal_parser.y"
{Opc |= (Reg);     ;
    break;}
case 94:
#line 236 "hal_parser.y"
{yyerror("%SYNTAX: use # for Immediate values\n");;
    break;}
case 95:
#line 237 "hal_parser.y"
{yyerror("%SYNTAX: IRegisters?");;
    break;}
case 96:
#line 240 "hal_parser.y"
{Opc |= ((31<<21) | (Reg<<16));;
    break;}
case 97:
#line 241 "hal_parser.y"
{Opc |= (Reg);	  ;
    break;}
case 98:
#line 242 "hal_parser.y"
{yyerror("Syntax, Registers?");;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 423 "bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) xmalloc(size + 15);
	  strcpy(msg, "parse error");

	  if (count < 5)
	    {
	      count = 0;
	      for (x = 0; x < (sizeof(yytname) / sizeof(char *)); x++)
		if (yycheck[x + yyn] == x)
		  {
		    strcat(msg, count == 0 ? ", expecting `" : " or `");
		    strcat(msg, yytname[x]);
		    strcat(msg, "'");
		    count++;
		  }
	    }
	  yyerror(msg);
	  free(msg);
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 244 "hal_parser.y"

/*****************************************************************************/
yyerror(s)
char *s;
{
static int counter =0;
 counter++;
 printf("%%HAL ERROR: %s \n\tAt line %d While processing token=<%s>\n",
				s,line_number,yylval);
 printf("             %s\n",Sline);
 fprintf(Ot,"%%HAL ERROR: %s \n\tAt line %d While processing token=<%s>\n",
				s,line_number,yylval);
 fprintf(Ot,"             %s\n",Sline);
 Kcode=1;			/* Do not generate code on Error*/
 if(counter==5)			/* After 5 fatal error, Die!*/
  {
   generate_list(NULL);
   exit(EXIT_FAILURE);
  };
 return;
}
/*****************************************************************************/
/* Update IC from PC							     */
/*****************************************************************************/
uic()
{      
/* Original equation: ic=(pc-Saddr)>>2; */
unsigned int a[2],b[2],c[2];
 a[1]=hpc;   a[0]=pc;
 b[1]=Sa[1]; b[0]=Sa[0];
 SUB64(a,b,c);
 ic = c[0] >> 2;
}
/*****************************************************************************/
/* Increment PC								     */
/*****************************************************************************/
ipc(d)
int d;
{
unsigned int a[2],b[2],c[2];
 a[1]=hpc; a[0]=pc;
 b[1]=0x0; b[0]=d;
 ADD64(a,b,c);
 hpc=c[1];
  pc=c[0];
 endline();
}
/*****************************************************************************/
/* Align PC								     */
/*****************************************************************************/
apc(d)
unsigned int d;
{
unsigned int a[2],b[2],c[2];
 d = (1 << d) - 1;  /* 2^d - 1 */
 if(!(pc & d)) return;
 pc &= ~d;
 d++;
 a[1]=hpc; a[0]=pc;
 b[1]=0x0; b[0]=d;
 ADD64(a,b,c);
 hpc=c[1];
  pc=c[0];
 uic();
 return;
}
/*****************************************************************************/
/* Align PC with filling						     */
/*****************************************************************************/
apcf(d,fv)
B32 d, fv;
{
unsigned int a[2],b[2],c[2];
B32	sic;
 d = (1 << d) - 1;  /* 2^d - 1 */
 if(!(pc & d)) return;
 pc &= ~d;
 d++;
 a[1]=hpc; a[0]=pc;
 b[1]=0x0; b[0]=d;
 ADD64(a,b,c);
 hpc=c[1];
  pc=c[0];
 sic=ic;
 uic(); 
 for(;sic<ic;sic++) m[sic]=fv;
 return;
}
/*****************************************************************************/
/*****************************************************************************/
dbug()
{
 fprintf(Ot,"Opc=%08X\n",Opc); 
 ref[ic].g  = 1;
 ref[ic].ln = line_number;
}
/*****************************************************************************/
/*****************************************************************************/
db()
{
 ref[ic].g  = 1;
 ref[ic].ln = line_number;
}
/*****************************************************************************/
/* RESET after each line						     */
/*****************************************************************************/
rs()
{
 st=0; 
 sop = NONE;
 strcpy(S1,"____");
 strcpy(S2,"____");
 strcpy(S3,"____");
}
/*****************************************************************************/
/* Used by Parser to concatenate the tokens                                  */
/*****************************************************************************/
YYSTYPE add(s1,s2)
char *s1, *s2;
{
 char *new;
 new = (char *)malloc((strlen(s1)+strlen(s2)+2) * sizeof(char));
 sscanf(new,"%s %s",s1,s2);
 if(s1[0] == '\0' || s1 == NULL) strcpy(new,s2);
 if(s2[0] == '\0' || s2 == NULL) strcpy(new,s1);
 return(new);
}

